import ResponseFactory from './ResponseFactory.ts'
import {Rehydratable} from '../../support/Rehydratable.ts'
import {Request} from '../Request.ts'

export default class DehydratedStateResponseFactory extends ResponseFactory {
    constructor(
        public readonly rehydratable: Rehydratable
    ) {
        super()
    }

    public async write(request: Request): Promise<Request> {
        request = await super.write(request)
        request.response.body = JSON.stringify(this.rehydratable.dehydrate())
        return request
    }
}
