import AppClass from '../../lifecycle/AppClass.ts'
import {Request} from '../Request.ts'

export default abstract class ResponseFactory extends AppClass {
    protected target_status: number = 200

    public async write(request: Request): Promise<Request> {
        request.response.status = this.target_status
        return request
    }

    public status(status: number): ResponseFactory {
        this.target_status = status
        return this
    }
}
