import ResponseFactory from './ResponseFactory.ts'
import {Request} from '../Request.ts'

export default class TemporaryRedirectResponseFactory extends ResponseFactory {
    protected target_status: number = 302

    constructor(
        public readonly destination: string,
    ) {
        super()
    }

    public async write(request: Request): Promise<Request> {
        request = await super.write(request)
        request.response.headers.set('Location', this.destination)
        return request
    }
}
