import SessionManagerFactory from './SessionManagerFactory.ts'
import ModelSessionManager from './ModelSessionManager.ts'
import {Model} from '../../../../orm/src/model/Model.ts'
import {StaticClass} from '../../../../di/src/type/StaticClass.ts'
import SessionInterface from './SessionInterface.ts'

export default class MemorySessionManagerFactory extends SessionManagerFactory {
    constructor(
        protected readonly ModelClass: StaticClass<SessionInterface, typeof Model>,
    ) {
        super()
    }

    produce(dependencies: any[], parameters: any[]): any {
        return new ModelSessionManager(this.ModelClass)
    }
}
