
export type JSONState = { [key: string]: string | boolean | number | undefined | JSONState | Array<string | boolean | number | undefined | JSONState> }

export function isJSONState(what: any): what is JSONState {
    try {
        JSON.stringify(what)
        return true
    } catch (e) {
        return false
    }
}

export interface Rehydratable {
    dehydrate(): Promise<JSONState>
    rehydrate(state: JSONState): void | Promise<void>
}
